/* utils.c generated by valac, the Vala compiler
 * generated from utils.vala, do not modify */

/*
 * Copyright (C) 2010 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by Mikkel Kamstrup Erlandsen <mikkel.kamstrup@canonical.com>
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gio/gdesktopappinfo.h>


#define UNITY_APPLICATIONS_PLACE_TYPE_SECTION (unity_applications_place_section_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

typedef enum  {
	UNITY_APPLICATIONS_PLACE_SECTION_ALL_APPLICATIONS = 0,
	UNITY_APPLICATIONS_PLACE_SECTION_ACCESSORIES,
	UNITY_APPLICATIONS_PLACE_SECTION_GAMES,
	UNITY_APPLICATIONS_PLACE_SECTION_INTERNET,
	UNITY_APPLICATIONS_PLACE_SECTION_MEDIA,
	UNITY_APPLICATIONS_PLACE_SECTION_OFFICE,
	UNITY_APPLICATIONS_PLACE_SECTION_SYSTEM,
	UNITY_APPLICATIONS_PLACE_SECTION_LAST_SECTION
} UnityApplicationsPlaceSection;



GType unity_applications_place_section_get_type (void) G_GNUC_CONST;
char* unity_applications_place_utils_get_section_name (UnityApplicationsPlaceSection section);
GAppInfo* unity_applications_place_utils_get_app_info_for_actor (const char* actor);



char* unity_applications_place_utils_get_section_name (UnityApplicationsPlaceSection section) {
	char* result = NULL;
	switch (section) {
		case UNITY_APPLICATIONS_PLACE_SECTION_ALL_APPLICATIONS:
		{
			result = g_strdup ("All Applications");
			return result;
		}
		case UNITY_APPLICATIONS_PLACE_SECTION_ACCESSORIES:
		{
			result = g_strdup ("Accessories");
			return result;
		}
		case UNITY_APPLICATIONS_PLACE_SECTION_GAMES:
		{
			result = g_strdup ("Games");
			return result;
		}
		case UNITY_APPLICATIONS_PLACE_SECTION_INTERNET:
		{
			result = g_strdup ("Internet");
			return result;
		}
		case UNITY_APPLICATIONS_PLACE_SECTION_MEDIA:
		{
			result = g_strdup ("Media");
			return result;
		}
		case UNITY_APPLICATIONS_PLACE_SECTION_OFFICE:
		{
			result = g_strdup ("Office");
			return result;
		}
		case UNITY_APPLICATIONS_PLACE_SECTION_SYSTEM:
		{
			result = g_strdup ("System");
			return result;
		}
		default:
		{
			result = g_strdup ("Internal Error");
			return result;
		}
	}
}


static char* string_substring (const char* self, glong offset, glong len) {
	char* result = NULL;
	glong string_length;
	const char* start;
	g_return_val_if_fail (self != NULL, NULL);
	string_length = g_utf8_strlen (self, -1);
	if (offset < 0) {
		offset = string_length + offset;
		g_return_val_if_fail (offset >= 0, NULL);
	} else {
		g_return_val_if_fail (offset <= string_length, NULL);
	}
	if (len < 0) {
		len = string_length - offset;
	}
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
	start = g_utf8_offset_to_pointer (self, offset);
	result = g_strndup (start, ((gchar*) g_utf8_offset_to_pointer (start, len)) - ((gchar*) start));
	return result;
}


GAppInfo* unity_applications_place_utils_get_app_info_for_actor (const char* actor) {
	GAppInfo* result = NULL;
	char* desktop_id;
	g_return_val_if_fail (actor != NULL, NULL);
	desktop_id = g_strdup (actor);
	if (g_str_has_prefix (desktop_id, "application://")) {
		char* _tmp1_;
		char* _tmp0_;
		desktop_id = (_tmp1_ = g_strdup (_tmp0_ = string_substring (desktop_id, (glong) 14, -1)), _g_free0 (desktop_id), _tmp1_);
		_g_free0 (_tmp0_);
	} else {
		if (g_str_has_prefix (desktop_id, "app://")) {
			char* _tmp3_;
			char* _tmp2_;
			desktop_id = (_tmp3_ = g_strdup (_tmp2_ = string_substring (desktop_id, (glong) 6, -1)), _g_free0 (desktop_id), _tmp3_);
			_g_free0 (_tmp2_);
		} else {
			if (g_str_has_prefix (desktop_id, "/")) {
				GFile* f;
				char* _tmp4_;
				f = g_file_new_for_path (desktop_id);
				desktop_id = (_tmp4_ = g_file_get_basename (f), _g_free0 (desktop_id), _tmp4_);
				_g_object_unref0 (f);
			}
		}
	}
	result = (GAppInfo*) g_desktop_app_info_new (desktop_id);
	_g_free0 (desktop_id);
	return result;
}




